#include <SPI.h>
#include <DMD.h>
#include <TimerOne.h>
#include "SystemFont5x7.h"
#include "Arial_black_16.h"
#include "Arial14.h"
#include "font4.h"
#define DISPLAYS_ACROSS 1
#define DISPLAYS_DOWN 1
String str;
char b[8];
DMD dmd(DISPLAYS_ACROSS, DISPLAYS_DOWN);
// Define analog input
#define ANALOG_IN_PIN A0
 
// Floats for ADC voltage & Input voltage
float adc_voltage = 0.0;
float in_voltage = 0.0;
 
// Floats for resistor values in divider (in ohms)
float R1 = 30000.0;
float R2 = 7500.0; 
 
// Float for Reference Voltage
float ref_voltage = 5.0;
 
// Integer for ADC value
int adc_value = 0; 
void ScanDMD(){
dmd.scanDisplayBySPI();
}
 
void setup() {
Serial.begin(9600);
Serial.println("DC Voltage Test");
Timer1.initialize(5000);
Timer1.attachInterrupt(ScanDMD);
dmd.clearScreen(true);
}
 
void loop()
{

    // Read the Analog Input
   adc_value = analogRead(ANALOG_IN_PIN);
   
   // Determine voltage at ADC input
   adc_voltage  = (adc_value * ref_voltage) / 1024.0; 
   
   // Calculate voltage at divider input
    in_voltage = adc_voltage / (R2/(R1+R2)) ; 
int slen = 0;
                          

dmd.selectFont(Arial_Black_16);               
str=(in_voltage);

  String mystr = "";
  if(in_voltage < 10){
   mystr += '0';
  }
 mystr += str;  
                                         
slen = mystr.length()-0;                                     
mystr.toCharArray(b,slen); 
  Serial.print("Input Voltage = ");
  Serial.println(in_voltage, 2);   
dmd.drawString(1,1,b,slen,GRAPHICS_NORMAL);    
delay(1000);
// dmd.clearScreen( true );  

}
